 type vyershyna=array[1..2] of integer;
  const vydodek:array[1..12] of vyershyna=
   ((1,1),
   (2,1),(2,2),(2,3),(2,4),(2,5),
   (3,1),(3,2),(3,3),(3,4),(3,5),
   (4,1));
   {12 vyershin,dlya kazhd.ukaz.Nr gruppy i Nr chlyena;
    1-ya gr. - "syev.polyus",
    2-ya - 5 chlyenov na obshch."parallyeli" k syev.ot ekvatora,
    3-ya - analog. - k yugu ot ekv.,
    4-ya - yuzhn.polyus.}
  const vyeikos:array[1..20] of vyershyna=
   ((1,1),(1,2),(1,3),(1,4),(1,5),
   (2,1),(2,2),(2,3),(2,4),(2,5),
   (3,1),(3,2),(3,3),(3,4),(3,5),
   (4,1),(4,2),(4,3),(4,4),(4,5));
   {20 vyershin,dlya kazhd.ukaz.Nr gruppy i Nr chlyena;
    1-ya gr. - 5-ugolhn.,vyersh. - na obshch.parall.vozlye "syev.polyusa",
    2-ya - 5 chlyenov na obshch."parallyeli" k syev.ot ekvatora,
    3-ya - analog. - k yugu ot ekv.,
    4-ya - analog.1-j - vozlye yuzhn.polyusa.}

 procedure dodeka(var co,si:real);
{Ishchem koord.vyersh.dodekaedra.Tri iz nikh:
        x                   y                   z
 r1     0                   0                   1
 r2     sin(f)*1            sin(f)*0            cos(f)
 r3     sin(f)*cos(2*pi/5)  sin(f)*sin(2*pi/5)  cos(f)
  Obozn.:c=cos(f),s=sin(f),cc=cos(2*pi/5).
 r1*r2=c; r1*r3 - to zhe; r2*r3=s^2*cc+c^2.
 obyaz.byth r1*r2=r1*r3=r2*r3 ->
 c=s^2*cc+c^2 => c=cc-cc*c^2+c^2 => (cc-1)*c^2+c-cc=0 - kvadr.ur.otn.c;
 vozvr.:co i si - cos(f) i sin(f).
 Kstati, co=sqrt(1/5), si=sqrt(1/5) .
}
 var cc,a,b,c,x1,x2,d:real; r1,r2,r3:array[1..3] of real;
begin
 cc:=cos(2*pi/5);
 a:=cc-1; b:=1; c:=-cc;
 x1:=(-b+sqrt(b*b-4*a*c))/(2*a);
 x2:=(-b-sqrt(b*b-4*a*c))/(2*a);
 co:=x1; si:=sqrt(1-co*co);
 {intyeryesno,chto sqr(co)=0.2000,khotya promyezh-no figurir.irrats.chislo
 cc=(-1+sqrt(5))/4; strogo li =1/5 - nyeyasno;
 poluch.vyr.dlya cc: cc+i*ss=exp(i*(2*pi/5)); (cc+i*ss)^5=1 ili,
 chto pozv.srazu sbith styepyenh,(cc+i*ss)^3=(cc+i*ss)^-2=(cc-i*ss)^2;
 podst.ss^2=1-cc^2 -> ur.otn.cc i ss,iz k-rogo izvlyek.vyr.dlya cc}
 r1[1]:=0; r1[2]:=0; r1[3]:=1;
 r2[1]:=si; r2[2]:=0; r2[3]:=co;
 r3[1]:=si*cos(2*pi/5); r3[2]:=si*sin(2*pi/5); r3[3]:=co;
 d:=r2[1]*r3[1]+r2[2]*r3[2]+r2[3]*r3[3];
 {writeln(d:12:6,co:12:6);}
 {vyp.d=co - provyerka vydyerzhana}
end;

 procedure eikosa(var c1,s1,c2,s2:real);
 {analog dodeka - dlya ikosaedra s C5 po osi Z nakh.cos i sin uglov,
  vkhod.v vyrazh.dlya koord.vyershin vida z=cos(f)}
 var co,si:real; r1,r2,r3,r:array[1..3] of real; i:integer;
 begin
  dodeka(co,si);
  r1[1]:=0; r1[2]:=0; r1[3]:=1;
  r2[1]:=si; r2[2]:=0; r2[3]:=co;
  r3[1]:=si*cos(2*pi/5); r3[2]:=si*sin(2*pi/5); r3[3]:=co;
  for i:=1 to 3 do r[i]:=r1[i]+r2[i]+r3[i];
  c1:=r[3]/sqrt(sqr(r[1])+sqr(r[2])+sqr(r[3])); s1:=sqrt(1-sqr(c1));
  r1[1]:=si; r1[2]:=0; r1[3]:=co;
  r2[1]:=si*cos(2*pi/5); r2[2]:=si*sin(2*pi/5); r2[3]:=co;
  r3[1]:=si*cos(2*pi/10); r3[2]:=si*sin(2*pi/10); r3[3]:=-co;
  for i:=1 to 3 do r[i]:=r1[i]+r2[i]+r3[i];
  c2:=r[3]/sqrt(sqr(r[1])+sqr(r[2])+sqr(r[3])); s2:=sqrt(1-sqr(c2));
 end;

 function cycl1(n,i,j:integer):boolean;
 {v n-chlyenn.tsyklye za i-m zvyenom slyed.j-ye}
 begin
  cycl1:=(i>=1) and (i<=n) and (j>=1) and (j<=n) and
  ((j=i+1) or ((i=n) and (j=1)));
 end;

 function cycl(n,i,j:integer):boolean;
 {v n-chlyenn.tsyklye i-ye i j-ye zvyenhya sosyedstv.}
 begin
  cycl:=cycl1(n,i,j) or cycl1(n,j,i)
 end;

 function svdodek1(i,j:integer):boolean;
 {yesth li pri vybr.numyerats.vyersh.dodekaedra napravlyenn.svyazh
  i-j i j-j vyershin}
  var v1,v2:vyershyna; k:integer;
 begin
  v1:=vydodek[i]; v2:=vydodek[j];
  k:=0;
  if (v1[1]=1) and (v2[1]=2) then k:=1;
  if (v1[1]=2) and (v2[1]=2) and cycl1(5,v1[2],v2[2]) then k:=1;
  if (v1[1]=2) and (v2[1]=3) and (v1[2]=v2[2]) then k:=1;
  if (v1[1]=2) and (v2[1]=3) and cycl1(5,v1[2],v2[2]) then k:=1;
  if (v1[1]=3) and (v2[1]=3) and cycl1(5,v1[2],v2[2]) then k:=1;
  if (v1[1]=3) and (v2[1]=4) then k:=1;
  svdodek1:=k=1
 end;

 function svdodek(i,j:integer):boolean; {to zhe,no svyazi nyenapravl.}
 begin
  svdodek:=svdodek1(i,j) or svdodek1(j,i)
 end;

 procedure rdodek(nr:integer; var x,y,z:real);
 { -> koord.nr-j vyershiny dodekaedra}
  var v:vyershyna; c,s,f:real;
 begin
  v:=vydodek[nr];
  dodeka(c,s);
  case v[1] of
   1: begin z:=1; x:=0; y:=0 end;
   2: begin z:=c; f:=(2*pi/5)*(v[2]-1); x:=s*cos(f); y:=s*sin(f) end;
   3: begin z:=-c; f:=(2*pi/5)*(v[2]-1.5); x:=s*cos(f); y:=s*sin(f) end;
   4: begin z:=-1; x:=0; y:=0 end;
   end;
  end;

 procedure reikos(nr:integer; var x,y,z:real);
 { -> koord.nr-j vyershiny ikosaedra}
  var v:vyershyna; c1,s1,c2,s2,f:real;
 begin
  v:=vyeikos[nr];
  eikosa(c1,s1,c2,s2);
  case v[1] of
   1: begin z:=c1; f:=(2*pi/5)*(v[2]-1); x:=s1*cos(f); y:=s1*sin(f) end;
   2: begin z:=c2; f:=(2*pi/5)*(v[2]-1); x:=s2*cos(f); y:=s2*sin(f) end;
   3: begin z:=-c2; f:=(2*pi/5)*(v[2]-1.5); x:=s2*cos(f); y:=s2*sin(f) end;
   4: begin z:=-c1; f:=(2*pi/5)*(v[2]-1.5); x:=s1*cos(f); y:=s1*sin(f) end;
  end;
 end;

 function sveikos1(i,j:integer):boolean;
 {yesth li pri vybr.numyerats.vyersh.ikosaedra napravlyenn.svyazh
  i-j i j-j vyershin}
  var v1,v2:vyershyna; k:integer;
 begin
  v1:=vyeikos[i]; v2:=vyeikos[j];
  k:=0;
  if (v1[1]=1) and (v2[1]=1) and cycl1(5,v1[2],v2[2]) then k:=1;
  if (v1[1]=1) and (v2[1]=2) and (v1[2]=v2[2]) then k:=1;
  if (v1[1]=2) and (v2[1]=3) and (v1[2]=v2[2]) then k:=1;
  if (v1[1]=2) and (v2[1]=3) and cycl1(5,v1[2],v2[2]) then k:=1;
  if (v1[1]=3) and (v2[1]=4) and (v1[2]=v2[2]) then k:=1;
  if (v1[1]=4) and (v2[1]=4) and cycl1(5,v1[2],v2[2]) then k:=1;
  sveikos1:=k=1
 end;

 function sveikos(i,j:integer):boolean; {to zhe,no svyazi nyenapravl.}
 begin
  sveikos:=sveikos1(i,j) or sveikos1(j,i)
 end;
