 procedure jacobi(var b,t:matr; n:integer; eps:real);
 {diag-tsija po Jakobi; v kontse sobstv. vekt. - stolbtsy matr. t}
 {tip matr neobkh. opis. v okhvat-shchej prog-me}
  var i,j,i1,j1,k,ic:integer; a,tg2fi,fi,s,c,a1,a2,sum:real;
  var coef:real;
  label ende;
 begin
  for i:=1 to n do for j:=1 to n do if i=j then t[i,j]:=1 else t[i,j]:=0;
  coef:=0;
  for i:=1 to n do for j:=1 to n do if abs(b[i,j])>coef then coef:=abs(b[i,j]);
  if coef=0 then goto ende;
  for i:=1 to n do for j:=1 to n do b[i,j]:=b[i,j]/coef;
  a:=0; sum:=0;
  for i:=1 to n do for j:=(i+1) to n do begin
   if abs(b[i,j])>a then begin i1:=i; j1:=j; a:=abs(b[i,j]) end;
   sum:=sum+sqr(b[i,j]);
  end;
  ic:=0; {writeln(ic:6,a:12:6,eps:12:6,sum:12:6);}
  while a>eps do begin
   i:=i1; j:=j1;
   if b[i,i]=b[j,j] then begin s:=sqrt(0.5); c:=sqrt(0.5) end
     else begin tg2fi:=2*b[i,j]/(b[i,i]-b[j,j]);
     fi:=0.5*arctan(tg2fi); s:=sin(fi); c:=cos(fi) end;
   for k:=1 to n do begin
    a1:=c*b[k,i]+s*b[k,j]; a2:=(-s)*b[k,i]+c*b[k,j];
    b[k,i]:=a1; b[k,j]:=a2 end;
   for k:=1 to n do begin
    a1:=c*b[i,k]+s*b[j,k]; a2:=(-s)*b[i,k]+c*b[j,k];
    b[i,k]:=a1; b[j,k]:=a2 end;
   for k:=1 to n do begin
    a1:=c*t[k,i]+s*t[k,j]; a2:=(-s)*t[k,i]+c*t[k,j];
    t[k,i]:=a1; t[k,j]:=a2 end;
   a:=0; sum:=0; {sound(900);} {v gol. prog.: uses crt;}
   for i:=1 to n do for j:=(i+1) to n do begin
    if abs(b[i,j])>a then begin i1:=i; j1:=j; a:=abs(b[i,j]) end;
    sum:=sum+sqr(b[i,j]);
   end; {nosound;}
   ic:=ic+1; {writeln('->ic,a,eps,sum=',ic:6,a:12:6,eps:12:6,sum:12:6);}
  end;
  for i:=1 to n do b[i,i]:=b[i,i]*coef;
  ende:
 end;

 procedure sortir(var h,t:matr; n:integer);
 {sortir. po vozrast. sobst. znach. posle diag-tsii}
  var i,j,k:integer; a:real;
 begin
  k:=n; while k>1 do begin {ostalos` upor`ad. k 1-kh vektorov}
   for j:=1 to (k-1) do if h[j,j]>h[j+1,j+1] then begin
    a:=h[j,j]; h[j,j]:=h[j+1,j+1]; h[j+1,j+1]:=a;
    for i:=1 to n do begin
     a:=t[i,j]; t[i,j]:=t[i,j+1]; t[i,j+1]:=a;
    end;
   end;
   k:=k-1;
  end;
 end;

